import { Component, input } from '@angular/core';
import { HotelItem } from './HotelItem/HotelItem.component';
import { SearchComponent } from './Search/search.component';
import { UpperCasePipe } from '@angular/common';
import { TextPipe } from '../text.pipe';
import { HotelService } from './Parent/services/hotel.service';
import { inject } from '@angular/core';
import { filter, map, Observable } from 'rxjs';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [HotelItem, SearchComponent, UpperCasePipe, TextPipe],
  templateUrl: './app.component.html',
  providers: [HotelService],
  styleUrl: './app.component.css'
})
export class AppComponent {
  public search: string = "";
  public hotelService: HotelService = inject(HotelService);

  ngOnInit() {
    const stream: Observable<number> = new Observable((observer) => {
      observer.next(1);
      observer.next(2);
      observer.next(3);
      observer.next(4);
      observer.next(5);
      observer.next(6);
      observer.next(7);
      observer.next(8);
      observer.next(9);
      observer.next(10);
      observer.complete();
    });

    stream.pipe(
      filter((value:number) => value % 2 === 1),
      map((value:number) => value * 2)
    ).subscribe((value) => console.log(value));
  }

  public test() {
    console.log(this.search);
  }

  public has_hotels(): boolean {
    for (let hotel of this.hotels) {
      if (hotel.hotelName.includes(this.search)) {
        return true;
      }
    }
    return false;
  }

  public hotels = this.hotelService.getHotels();
}

